import {
  select,
  csv,
  scaleLinear,
  scaleTime,
  extent,
  axisLeft,
  axisBottom,
  line,
  curveBasis
} from 'd3';


const svg = select('svg');
const height = +(svg.attr('height'));
const width = +(svg.attr('width'));
const render = data =>{
  const xValue = d =>d.timestamp;
  const xAxisLabel = 'Timestamp'
  const yValue = d=> d.Caradano;
  const yAxisLabel = 'Caradano Rate'
  const circleRadius = 6;
  const title = 'Rate change of Caradano in the Market';
  const margin = {top: 75, rigth: 50, bottom: 80, left: 100}
  const innerWidth = width -margin.left - margin.rigth;
  const innerHeight = height - margin.top - margin.bottom;
  
  const xScale = scaleTime()
  	.domain(extent(data,xValue))
  	.range([0,innerWidth])
  	.nice();
  
  const yScale = scaleLinear()
  	.domain(extent(data,yValue))
  	.range([innerHeight,0])
  	.nice();
  
	const g = svg.append('g')
  	.attr('transform',`translate(${margin.left},${margin.top})`);
  
  const xAxis = axisBottom(xScale)
  	.tickSize(-innerHeight)
  	.tickPadding(15);
  
  const yAxis = axisLeft(yScale)
  	.tickSize(-innerWidth)
  	.tickPadding(5);
  
  const yAxisG = g.append('g')
                .call(yAxis)
  yAxisG.selectAll('.domain')
        	.remove();
  
  yAxisG.append('text')
  	.attr('class','axis-label')
  	.attr('x',-innerHeight/2)
  	.attr('y',-50)
  	.attr('fill','black')
  	.attr('text-anchor','middle')
  	.attr('transform',`rotate(-90)`)
    .text(yAxisLabel);
  
 	const xAxisG = g.append('g').call(xAxis)
                  .attr('transform',`translate(0,${innerHeight})`)
  xAxisG.select('.domain').remove();
  

  xAxisG.append('text')
  	.attr('class','axis-label')
  	.attr('x',innerWidth/2)
  	.attr('y',70)
    .attr('fill','black')
    .text(xAxisLabel)
  

  const lineGenerator = line()
  	.x(d =>xScale(xValue(d)))
  	.y(d=>yScale(yValue(d)))
  	.curve(curveBasis);
  
  g.append('path')
  	.attr('class','line-path')
  	.attr('stroke','black')
  	.attr('d', lineGenerator(data))
  
  g.append('text')
  	.attr('class','title')
    .attr('x',innerWidth/2)
  	.attr('y',-10)
  	.attr('text-anchor','middle')
  	.text(title);
};
// Dataset URL
csv('https://gist.githubusercontent.com/SatyaVineeth/a777e383f454bf3a26dd0ced913e15e0/raw/bca2905cc3d2d092b7e4b553fc77b8091c3fd288/Caradano%2520Timestamp')
  .then(data =>{
    data.forEach(d =>{
      d.Caradano= +d.Caradano;
			d.timestamp = new Date(d.timestamp);
    });
    render(data);
});
